function [A,b] = lu_zerlegung_spaltenpivotsuche(A,b)
%LU_ZERLEGUNG_SPALTENPIVOTSUCHE - zerlegt gegebene Matrix A in A = LU (U obere Dreiecksmatrix, L untere Dreiecksmatrix) mit Spaltenpivotsuche

[zeilen,spalten] = size(A);
for k = 1:(spalten-1)
    [maximum,index_max] = max(abs(A([k:zeilen],k)));
    index_max = k-1+index_max;
    if (index_max ~= k)
        h = b(k);
        b(k) = b(index_max);
        b(index_max) = h;
        for i = 1:spalten
            h = A(k,i);
            A(k,i) = A(index_max,i);
            A(index_max,i) = h;
        end
    end
    for i = (k + 1):zeilen
        if A(k,k) ~= 0
            A(i,k) = A(i,k)/A(k,k);
            for j = (k + 1):spalten
                A(i,j) = A(i,j) - A(i,k)*A(k,j);
            end
        else sprintf('Diagonalelement = 0!')
        end
    end
end
end